accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts.views import (
    sign_up,
)

urlpatterns = [
    path(
        "login/",
        auth_views.LoginView.as_view(),
        name="login",
    ),
    path(
        "logout/",
        auth_views.LogoutView.as_view(),
        name="logout",
    ),
    path("signup/", sign_up, name="sign_up"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import path, include, reverse_lazy
from django.views.generic.base import RedirectView

urlpatterns = [
    path("receipts/", include("receipts.urls")),
    path("admin/", admin.site.urls),
    path("accounts/", include("accounts.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("home")),
    ),
]

receipts/urls.py
from django.contrib import admin
from django.urls import path

# from django.contrib.auth import views as auth_views

from receipts.views import (
    ReceiptsListView,
    ReceiptsCreateView,
    AccountCreateView,
    AccountListView,
    ExpenseCategoryListView,
    ExpenseCategoryCreateView,
)


urlpatterns = [
    # path(
    #     "accounts/login/",
    #     auth_views.LoginView.as_view(),
    #     name="login",
    # ),
    # path(
    #     "accounts/logout/",
    #     auth_views.LogoutView.as_view(),
    #     name="logout",
    # ),
    # path("accounts/signup/", signup, name="sign_up"),
    path("", ReceiptsListView.as_view(), name="home"),
    path("create/", ReceiptsCreateView.as_view(), name="receipts_new"),
    path("accounts/", AccountListView.as_view(), name="accounts_list"),
    path("accounts/create/", AccountCreateView.as_view(), name="accounts_new"),
    path(
        "categories/",
        ExpenseCategoryListView.as_view(),
        name="categories_list",
    ),
    path(
        "categories/create/",
        ExpenseCategoryCreateView.as_view(),
        name="categories_new",
    ),
]

accounts/models.py
# from django.db import models
# from django.conf import settings

# USER_MODEL = settings.AUTH_USER_MODEL

# class Accounts(models.Model):
#     name = models.ForeignKey(
#         USER_MODEL,
#         on_delete=models.CASCADE,
#         null=True,
#     )
#     number = models.PositiveSmallIntegerField(
#         null=True),
#     receipts = models.ForeignKey(
#         on_delete=models.CASCADE,
#         null=True
#     )

receipts/models.py
from unicodedata import category
from django.db import models
from django.conf import settings

# Create your models here.

USER_MODEL = settings.AUTH_USER_MODEL


class Receipts(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(
        max_digits=10,
        decimal_places=3,
        null=True,
    )
    tax = models.DecimalField(max_digits=10, decimal_places=3, null=True)
    date = models.DateTimeField(blank=True, null=True)
    purchaser = models.ForeignKey(
        USER_MODEL,
        related_name="receipts",
        on_delete=models.CASCADE,
        null=True,
    )
    category = models.ForeignKey(
        "ExpenseCategory",
        related_name="receipts",
        on_delete=models.CASCADE,
        null=True,
    )
    account = models.ForeignKey(
        "Account",
        related_name="receipts",
        on_delete=models.CASCADE,
        null=True,
    )


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="categories",
        on_delete=models.CASCADE,
        null=True,
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20, null=True)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="accounts",
        on_delete=models.CASCADE,
        null=True,
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login


def sign_up(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            usernameAPP = request.POST.get("username")
            passwordAPP = request.POST.get("password1")
            # User is a model with a function create_user
            # setting our variables usernameAPP and passwordAPP
            # to the create_user parameters
            user = User.objects.create_user(
                username=usernameAPP, password=passwordAPP
            )
            user.save()
            login(request, user)
            return render(request, "home")
    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/sign_up.html", context)

receipts/views.py
from django.shortcuts import render
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login
from django.urls import reverse_lazy
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView

from receipts.models import Receipts, Account, ExpenseCategory

# from django.contrib.auth.decorators import login_required
# Create your views here.


class ReceiptsListView(ListView):
    model = Receipts
    template_name = "receipts/list.html"


class ReceiptsCreateView(CreateView):
    model = Receipts
    template_name = "receipts/new.html"
    fields = [
        "vendor",
        "total",
        "tax",
        "date",
        "category",
        "account",
    ]
    success_url = reverse_lazy("receipts_list")


class AccountListView(ListView):
    model = Account
    template_name = "accounts/list.html"


class AccountCreateView(CreateView):
    model = Account
    template_name = "accounts/new.html"
    fields = [
        "name",
        "number",
    ]
    success_url = reverse_lazy("accounts_list")


class ExpenseCategoryListView(ListView):
    model = ExpenseCategory
    template_name = "categories/list.html"


class ExpenseCategoryCreateView(CreateView):
    model = ExpenseCategory
    template_name = "categories/new.html"
    fields = ["name"]
    success_url = reverse_lazy("categories_list")


###### moving to accounts.view.py
# def signup(request):
#     if request.method == "POST":
#         form = UserCreationForm(request.POST)
#         if form.is_valid():
#             usernameAPP = request.POST.get("username")
#             passwordAPP = request.POST.get("password1")
#             # User is a model with a function create_user
#             # setting our variables usernameAPP and passwordAPP
#             # to the create_user parameters
#             user = User.objects.create_user(
#                 username=usernameAPP, password=passwordAPP
#             )
#             user.save()
#             login(request, user)
#             return render(request, "home")
#     else:
#         form = UserCreationForm(request.POST)
#     context = {"form": form}
#     return render(request, "registration/sign_up.html", context)


### whatever I got from the internet
# def sign_up(request):
#     context = {}
#     form = UserCreationForm(request.POST or None)
#     if request.method == "POST":
#         if form.is_valid():
#             user = form.save()
#             login(request, user)
#             return render(request, "receipts/list.html")
#     context["form"] = form
#     return render(request, "registration/sign_up.html", context)

receipts/templates/accounts/list.html
{% extends 'base.html' %}

{% block content %}
<h1>Accounts</h1>
<p><p>
    <table>
        <thead>
            <tr>
                <th>Name</th>
                <th>Number</th>
                <th>Number of receipts</th>
            </tr>
        </thead>
        <tbody>
            {% for account in account_list %}
            <tr>
                <td>
                    {{ account.name }}
                </td>
                <td>
                    {{ account.number }}
                </td>
                <td>
                    {% comment %} why this works: referencing account
                     model, the related_name="receipts" from class 
                     Receipts, and pulling all {% endcomment %}
                    {{ account.receipts.all|length }}
                </td>
            </tr>
            {% endfor %}
        <tbody>
    </table>
{% endblock content %}

receipts/templates/accounts/new.html
{% extends 'base.html' %}

{% block content %}
<h1>Create Account</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
{% endblock content %}

receipts/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
    <head>
        <title>Receipts</title>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="stylesheet" href="{% static 'css/app.css' %}">
    </head>
    <body>
        <header>
            <nav>
                <ul>
                    <li>
                        <a href="{% url 'home' %}">Receipts</a>
                    </li>
                    <li>
                        <a href="{% url 'receipts_new' %}">Create receipt</a>
                    </li>
                    <li>
                        <a href="{% url 'accounts_list' %}">Accounts</a>
                    </li>
                    <li>
                        <a href="{% url 'accounts_new' %}">Create account<a/>
                    </li>
                    <li>
                        <a href="{% url 'categories_list' %}">Categories</a>
                    </li>
                    <li>
                        <a href="{% url 'categories_new' %}">Create category</a>
                    </li>
                    <li>
                        <a href="{% url 'logout' %}">Logout</a>
                    </li>
                </ul>
            </nav>
        </header>
        {% block content %}
        {% endblock content %}
    </body>
</html>

receipts/templates/categories/list.html
{% extends 'base.html' %}

{% block content %}
<h1>Expense Categories</h1>
<p><p>
    <table>
        <thead>
            <tr>
                <th>Name</th>
                <th>Number of receipts</th>
            </tr>
        </thead>
        <tbody>
            {% for category in expensecategory_list %}
            <tr>
                <td>
                    {{ category.name }}
                </td>
                <td>
                    {{ category.receipts.all|length }}
                </td>
            </tr>
            {% endfor %}
        <tbody>
    </table>
{% endblock content %}

receipts/templates/categories/new.html
{% extends 'base.html' %}

{% block content %}
<h1>Create Expense Category</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
{% endblock content %}

receipts/templates/receipts/list.html
{% extends 'base.html' %}

{% block content %}
<h1>Receipts</h1>
<p><p>
    <table>
        <thead>
            <tr>
                <th>Vendor</th>
                <th>Total</th>
                <th>Tax</th>
                <th>Date</th>
                <th>Category</th>
                <th>Account</th>
            </tr>
        </thead>
        <tbody>
            {% for receipt in receipts_list %}
            <tr>
                <td>
                    {{ receipt.vendor }}
                </td>
                <td>
                    {{ receipt.total }}
                </td>
                <td>
                    {{ receipt.tax }}
                </td>
                <td>
                    {{ receipt.date }}
                </td>
                <td>
                    {{ receipt.category }}
                </td>
                <td>
                    {{ receipt.account }}
                </td>
            </tr>
            {% endfor %}
        <tbody>
    </table>
{% endblock content %}

receipts/templates/receipts/new.html
{% extends 'base.html' %}

{% block content %}
<h1>Create Receipt</h1>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
{% endblock content %}